3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be taken to unexpected places. If you
10 # like CDPATH, define it for your interactive shell sessions without
21 if test -n "$OPTIONS_SPEC"; then
28 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
29 parseopt_extra
="--keep-dashdash"
32 echo "$OPTIONS_SPEC" |
33 git rev-parse --parseopt $parseopt_extra -- "$@
" ||
37 dashless
=$
(basename "$0" |
sed -e 's/-/ /')
39 die
"Usage: $dashless $USAGE"
42 if [ -z "$LONG_USAGE" ]
44 LONG_USAGE
="Usage: $dashless $USAGE"
46 LONG_USAGE
="Usage: $dashless $USAGE
52 -h|
--h|
--he|
--hel|
--help)
59 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
61 GIT_REFLOG_ACTION
="$*"
62 export GIT_REFLOG_ACTION
67 : "${GIT_EDITOR:=$(git config core.editor)}"
68 : "${GIT_EDITOR:=${VISUAL:-${EDITOR}}}"
69 case "$GIT_EDITOR,$TERM" in
71 echo >&2 "No editor specified in GIT_EDITOR, core.editor, VISUAL,"
72 echo >&2 "or EDITOR. Tried to fall back to vi but terminal is dumb."
73 echo >&2 "Please set one of these variables to an appropriate"
74 echo >&2 "editor or run $0 with options that will not cause an"
75 echo >&2 "editor to be invoked (e.g., -m or -F for git-commit)."
79 eval "${GIT_EDITOR:=vi}" '"$@"'
82 is_bare_repository
() {
83 git rev-parse
--is-bare-repository
87 cdup
=$
(git rev-parse
--show-cdup)
90 # The "-P" option says to follow "physical" directory
91 # structure instead of following symbolic links. When cdup is
92 # "../", this means following the ".." entry in the current
93 # directory instead textually removing a symlink path element
94 # from the PWD shell variable. The "-P" behavior is more
95 # consistent with the C-style chdir used by most of Git.
97 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
103 require_work_tree
() {
104 test $
(git rev-parse
--is-inside-work-tree) = true ||
105 die
"fatal: $0 cannot be used without a working tree."
108 get_author_ident_from_commit
() {
111 s/'\''/'\''\\'\'\''/g
113 s/^author \([^<]*\) <[^>]*> .*$/\1/
115 s
/.
*/GIT_AUTHOR_NAME
='\''&'\''/p
118 s
/^author
[^
<]* <\
([^
>]*\
)> .
*$
/\
1/
120 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
123 s/^author [^<]* <[^>]*> \(.*\)$/\1/
125 s
/.
*/GIT_AUTHOR_DATE
='\''&'\''/p
130 encoding=$(git config i18n.commitencoding || echo UTF-8)
131 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
132 LANG=C LC_ALL=C sed -ne "$pick_author_script"
135 # Make sure we are in a valid repository of a vintage we understand,
136 # if we require to be in a git repository.
137 if test -z "$NONGIT_OK"
139 GIT_DIR=$(git rev-parse --git-dir) || exit
140 if [ -z "$SUBDIRECTORY_OK" ]
142 test -z "$(git rev-parse --show-cdup)" || {
144 echo >&2 "You need to run this command from the toplevel of the working tree."
148 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
149 echo >&2 "Unable to determine absolute path of git directory"
152 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
155 # Fix some commands on Windows
158 # Windows has its own (incompatible) sort and find